JUCE: ValueTreePropertyWithDefault Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
ValueTreePropertyWithDefault Class Reference
juce_data_structures » values

This class acts as a wrapper around a property inside a ValueTree. More...

`#include <juce_ValueTreePropertyWithDefault.h>`

Inheritance diagram for ValueTreePropertyWithDefault:

## Public Member Functions
| ValueTreePropertyWithDefault ()=default
| Creates an uninitialised ValueTreePropertyWithDefault object.
| ValueTreePropertyWithDefault (ValueTree &tree, const Identifier &propertyID, UndoManager *um)
| Creates a ValueTreePropertyWithDefault object for the specified property.
| ValueTreePropertyWithDefault (ValueTree &tree, const Identifier &propertyID, UndoManager *um, var defaultToUse)
| Creates an ValueTreePropertyWithDefault object for the specified property.
| ValueTreePropertyWithDefault (ValueTree &tree, const Identifier &propertyID, UndoManager *um, var defaultToUse, StringRef arrayDelimiter)
| Creates a ValueTreePropertyWithDefault object for the specified property.
| ValueTreePropertyWithDefault (const ValueTreePropertyWithDefault &other)
| Creates a ValueTreePropertyWithDefault object from another ValueTreePropertyWithDefault object.
| ~ValueTreePropertyWithDefault () override
| Destructor.
var | get () const noexcept
| Returns the current value of the property.
Value | getPropertyAsValue ()
| Returns the current property as a Value object.
var | getDefault () const
| Returns the current default value.
void | setDefault (const var &newDefault)
| Sets the default value to a new var.
bool | isUsingDefault () const
| Returns true if the property does not exist in the referenced ValueTree.
void | resetToDefault () noexcept
| Removes the property from the referenced ValueTree.
ValueTreePropertyWithDefault & | operator= (const var &newValue)
| Sets the property and returns the new ValueTreePropertyWithDefault.
void | setValue (const var &newValue, UndoManager *undoManagerToUse)
| Sets the property.
void | referTo (ValueTree tree, const Identifier &property, UndoManager *um)
| Makes the ValueTreePropertyWithDefault refer to the specified property inside the given ValueTree.
void | referTo (ValueTree tree, const Identifier &property, UndoManager *um, var defaultVal)
| Makes the ValueTreePropertyWithDefault refer to the specified property inside the given ValueTree.
void | referTo (ValueTree tree, const Identifier &property, UndoManager *um, var defaultVal, StringRef arrayDelimiter)
| Makes the ValueTreePropertyWithDefault refer to the specified property inside the given ValueTree.
ValueTree & | getValueTree () noexcept
| Returns a reference to the ValueTree containing the referenced property.
Identifier & | getPropertyID () noexcept
| Returns the property ID of the referenced property.
UndoManager * | getUndoManager () noexcept
| Returns the UndoManager that is being used.
ValueTreePropertyWithDefault & | operator= (const ValueTreePropertyWithDefault &other)

## Public Attributes
std::function< void()> | onDefaultChange
| You can assign a lambda to this callback and it will called when the default value is changed.

## Detailed Description

This class acts as a wrapper around a property inside a ValueTree.

If the property inside the ValueTree is missing it will return a default value, which can be specified in the constructor or by calling setDefault().

## Constructor & Destructor Documentation

## ◆ ValueTreePropertyWithDefault() [1/5]

ValueTreePropertyWithDefault::ValueTreePropertyWithDefault | ( |  | ) |
| default

Creates an uninitialised ValueTreePropertyWithDefault object.

Initialise it using one of the referTo() methods.

## ◆ ValueTreePropertyWithDefault() [2/5]

ValueTreePropertyWithDefault::ValueTreePropertyWithDefault | ( | ValueTree & | tree,
|  | const Identifier & | propertyID,
|  | UndoManager * | um
| ) |  |

Creates a ValueTreePropertyWithDefault object for the specified property.

The default value will be an empty var.

References Value::referTo(), and tree.

## ◆ ValueTreePropertyWithDefault() [3/5]

ValueTreePropertyWithDefault::ValueTreePropertyWithDefault | ( | ValueTree & | tree,
|  | const Identifier & | propertyID,
|  | UndoManager * | um,
|  | var | defaultToUse
| ) |  |

Creates an ValueTreePropertyWithDefault object for the specified property.

The default value will be defaultToUse.

References Value::referTo(), and tree.

## ◆ ValueTreePropertyWithDefault() [4/5]

ValueTreePropertyWithDefault::ValueTreePropertyWithDefault | ( | ValueTree & | tree,
|  | const Identifier & | propertyID,
|  | UndoManager * | um,
|  | var | defaultToUse,
|  | StringRef | arrayDelimiter
| ) |  |

Creates a ValueTreePropertyWithDefault object for the specified property.

The default value will be defaultToUse.

Use this constructor if the underlying var object being controlled is an array and it will handle the conversion to/from a delimited String that can be written to XML format.

References Value::referTo(), and tree.

## ◆ ValueTreePropertyWithDefault() [5/5]

ValueTreePropertyWithDefault::ValueTreePropertyWithDefault | ( | const ValueTreePropertyWithDefault & | other | ) |

Creates a ValueTreePropertyWithDefault object from another ValueTreePropertyWithDefault object.

## ◆ ~ValueTreePropertyWithDefault()

ValueTreePropertyWithDefault::~ValueTreePropertyWithDefault | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ get()

var ValueTreePropertyWithDefault::get | ( |  | ) | const
| noexcept

Returns the current value of the property.

If the property does not exist this returns the default value.

References Value::toString().

## ◆ getPropertyAsValue()

Value ValueTreePropertyWithDefault::getPropertyAsValue | ( |  | ) |

Returns the current property as a Value object.

## ◆ getDefault()

var ValueTreePropertyWithDefault::getDefault | ( |  | ) | const

Returns the current default value.

## ◆ setDefault()

void ValueTreePropertyWithDefault::setDefault | ( | const var & | newDefault | ) |

Sets the default value to a new var.

## ◆ isUsingDefault()

bool ValueTreePropertyWithDefault::isUsingDefault | ( |  | ) | const

Returns true if the property does not exist in the referenced ValueTree.

## ◆ resetToDefault()

void ValueTreePropertyWithDefault::resetToDefault | ( |  | ) |
| noexcept

Removes the property from the referenced ValueTree.

## ◆ operator=() [1/2]

ValueTreePropertyWithDefault & ValueTreePropertyWithDefault::operator= | ( | const var & | newValue | ) |

Sets the property and returns the new ValueTreePropertyWithDefault.

This will modify the property in the referenced ValueTree.

References Value::setValue().

## ◆ setValue()

void ValueTreePropertyWithDefault::setValue | ( | const var & | newValue,
|  | UndoManager * | undoManagerToUse
| ) |  |

Sets the property.

This will modify the property in the referenced ValueTree.

References var::getArray().

## ◆ referTo() [1/3]

void ValueTreePropertyWithDefault::referTo | ( | ValueTree | tree,
|  | const Identifier & | property,
|  | UndoManager * | um
| ) |  |

Makes the ValueTreePropertyWithDefault refer to the specified property inside the given ValueTree.

The default value will be an empty var.

References tree.

## ◆ referTo() [2/3]

void ValueTreePropertyWithDefault::referTo | ( | ValueTree | tree,
|  | const Identifier & | property,
|  | UndoManager * | um,
|  | var | defaultVal
| ) |  |

Makes the ValueTreePropertyWithDefault refer to the specified property inside the given ValueTree.

The default value will be defaultVal.

References tree.

## ◆ referTo() [3/3]

void ValueTreePropertyWithDefault::referTo | ( | ValueTree | tree,
|  | const Identifier & | property,
|  | UndoManager * | um,
|  | var | defaultVal,
|  | StringRef | arrayDelimiter
| ) |  |

Makes the ValueTreePropertyWithDefault refer to the specified property inside the given ValueTree.

The default value will be defaultVal.

References tree.

## ◆ getValueTree()

ValueTree & ValueTreePropertyWithDefault::getValueTree | ( |  | ) |
| noexcept

Returns a reference to the ValueTree containing the referenced property.

## ◆ getPropertyID()

Identifier & ValueTreePropertyWithDefault::getPropertyID | ( |  | ) |
| noexcept

Returns the property ID of the referenced property.

## ◆ getUndoManager()

UndoManager * ValueTreePropertyWithDefault::getUndoManager | ( |  | ) |
| noexcept

Returns the UndoManager that is being used.

## ◆ operator=() [2/2]

ValueTreePropertyWithDefault & ValueTreePropertyWithDefault::operator= | ( | const ValueTreePropertyWithDefault & | other | ) |

## Member Data Documentation

## ◆ onDefaultChange

std::function<void()> ValueTreePropertyWithDefault::onDefaultChange

You can assign a lambda to this callback and it will called when the default value is changed.

See also
  setDefault

The documentation for this class was generated from the following file:

- juce_ValueTreePropertyWithDefault.h